
import 'package:flutter_mylibrary/utils/utils.dart';
import '../base_view_state.dart';
import 'base_view_state_getx_controller.dart';


abstract class GetxRequestListController<T> extends BaseViewStateGetxController{


  /// 页面数据
  List<T> list = [];

  onCompleted(List<T> data) {}


  @override
  void onReady(){
    getData();
  }


  ///获取数据
  void getData(){
    request((data){
      if (isNotEmpty(data)) {
        list = data is List? List<T>.from(data.map((e) => getRequestInfo()?.handleRes(e))).toList() : getRequestInfo()?.handleRes(data);
        onCompleted(list);
      }else{
        errorType = ViewStateErrorType.noDataError;
        setError(
          errorType: errorType,
        );
      }
    });
  }
}