import 'package:event_bus/event_bus.dart';
import 'package:flutter/material.dart';
import 'package:flutter_mylibrary/base/base_view_state.dart';
import 'package:flutter_mylibrary/base/provider/view_state_model.dart';
import 'package:flutter_mylibrary/flutter_mylibrary.dart';
import 'package:flutter_mylibrary/utils/win_media.dart';
import 'package:flutter_mylibrary/widget/widget_template.dart';
import 'package:flutter_spinkit/flutter_spinkit.dart';
import 'package:logger/logger.dart';
import 'package:synchronized/synchronized.dart';


final EventBus publicEventBus = EventBus();

int startPage = 1;

int pageLimit = 10;

bool centerTitle = true;

double defMargin = 15;

Lock get lock => Lock();

Logger get logger => Logger(
  printer: PrettyPrinter(),
);

const String defPassword = "@#\$0142365987CDKJDIEWQD@#\$%\^&!!";

const String rsaSplit = "------------$defPassword-------------";

/// **********************************************Widget配置*************************************************************************************/

///loading
Widget get pageLoading => SpinKitWave(color: Theme.of(Get.context).primaryColor, type: SpinKitWaveType.start, size: getSp(24),);

///空数据布局
ViewStateModelEmptyWidgetBuilder emptyWidget = (ViewStateError viewStateError, BaseViewState viewStateModel) => buildNoDataWidget(viewStateError: viewStateError, viewStateModel: viewStateModel);

ViewStateModelErrorWidgetBuilder errorWidget = (ViewStateError viewStateError, BaseViewState viewStateModel) => buildNoDataWidget(viewStateError: viewStateError, viewStateModel: viewStateModel);


/// **********************************************设置网络错误提示*************************************************************************************/


String CONNECT_TIMEOUT_MSG = "网络连接超时，请检查网络设置";
String RECEIVE_TIMEOUT_MSG = "服务器异常，请稍后重试！";
String SEND_TIMEOUT_MSG = "网络连接超时，请检查网络设置";
String HTTP_ERROR_MSG = "服务器异常，请稍后重试！";
String CANCEL_MSG = "请求已被取消，请稍后重试！";
String NO_DATA = '无数据';
String UNAUTHORIZED = '未允许授权';
String NETWORK_ERROR = '网络错误';
String SSL_ERROR = '证书错误';
String UNKNOWN = '未知错误';
String CODE_INCORRECT = '请求code错误';
String PARSE_ERROR = '数据解析错误';

/// **********************************************公用key*************************************************************************************/
const String loginKey = 'loginKey';

const String userKey = 'userKey';

const String themeKey = 'themeKey';

const kThemeUserDarkMode = 'kThemeUserDarkMode';

const kThemeColor = 'kThemeColor';


/// **********************************************EventBus公用类*************************************************************************************/
class CourseScheduleRefreshEvent {}





/// **********************************************自定义方法名*************************************************************************************/
typedef ViewStateModelWidgetBuilder<T> = Widget Function(T value);

typedef ViewStateModelWidgetListBuilder<T> = List<Widget> Function(T value);

typedef ViewStateModelEmptyWidgetBuilder = Widget Function(ViewStateError viewStateError, BaseViewState viewStateModel);

typedef ViewStateModelErrorWidgetBuilder = Widget Function(ViewStateError viewStateError, BaseViewState viewStateModel);

typedef ViewPortBuilder = void Function(int firstIndex, int lastIndex);

typedef ValidateResponse = void Function(dynamic data);

typedef GetxViewStateModelWidgetBuilder<T> = Widget Function(BuildContext context, T model);
